accounts/urls.py
# accounts/urls.py
from django.urls import path
from django.contrib.auth.decorators import login_required

from . import views
from accounts import views as user_views

app_name = 'account'
urlpatterns = [
    path('signup/', views.SignUp.as_view(), name='signup'),
	path('profile/', user_views.profile, name='profile'),
	path('load_profile_picture/', user_views.loadProfilePicture, name='load_profile_picture'),
]

gestion_projets/urls.py
from django.urls import path
from django.contrib.auth.decorators import login_required

from .views import *

app_name = 'gestion_projets'
urlpatterns = [
    # Subjects Views
    path('subjects/', login_required(views_subjects.SubjectsView.as_view()), name='subject_list'),
    path('subject/new/', login_required(views_subjects.SubjectNew.as_view()), name='subject_new'),
	path('subject/view/<int:pk>/', login_required(views_subjects.SubjectViewDetailView.as_view()), name='subject_view'),
	path('subject/edit/<int:pk>/', login_required(views_subjects.SubjectEditDetailView.as_view()), name='subject_edit'),
	
    path('subjectFn/<int:subject_id>/', views_subjects.subjectFn, name='subject_Fn'),
    path('subjectFnNew/', views_subjects.subjectFnNew, name='subject_FnNew'),
    
    # Sessions Views
    path('sessions/', login_required(views_sessions.SessionsView.as_view()), name='session_list'),
	path('sessions/view/<int:pk>/', login_required(views_sessions.SessionViewDetailView.as_view()), name='session_view'),

	path('sessions/add_subject/<int:session_id>/<int:subject_id>', views_sessions.SessionAddSubject, name='session_add_subject'),
	path('sessions/remove_subject/<int:session_id>/<int:subject_id>', views_sessions.SessionRemoveSubject, name='session_remove_subject'),
    path('sessions/choose_subject/<int:session_id>/<int:subject_id>', views_sessions.SessionChooseSubject, name='session_choose_subject'),
    
    path('sessions/quit_project/<int:session_id>/<int:project_id>', views_sessions.SessionQuitProject, name='session_quit_project'),
    path('sessions/validate_project/<int:session_id>/<int:project_id>', views_sessions.ProjectValidateTutor, name='project_validate_tutor'),
    path('sessions/validate_project_admin/<int:session_id>/<int:project_id>', views_sessions.ProjectValidateAdmin, name='project_validate_admin'),
    path('sessions/project_remove_student/<int:session_id>/<int:project_id>/<int:user_id>', views_sessions.ProjectRemoveStudent, name='project_remove_student'),
    path('sessions/project_add_student/<int:session_id>/<int:project_id>', views_sessions.ProjectAddStudent, name='project_add_student'),

    path('sessions/create_group_selection/<int:session_id>', views_sessions.CreateGroupSelection, name='create_group_selection'),
    path('sessions/join_group_selection/<int:session_id>/<int:group_id>', views_sessions.JoinGroupSelection, name='join_group_selection'),
    path('sessions/quit_group_selection/<int:session_id>/<int:group_id>', views_sessions.QuitGroupSelection, name='quit_group_selection'),
    path('sessions/save_group_selection/<int:session_id>/<int:group_id>', views_sessions.SaveGroupSelection, name='save_group_selection'),
    path('sessions/create_project_selection/<int:session_id>', views_sessions.CreateProjectSelection, name='create_project_selection'),
    path('sessions/step_project_selection/<int:session_id>', views_sessions.StepProjectSelection, name='step_project_selection'),
    path('sessions/all_step_project_selection/<int:session_id>', views_sessions.AllStepProjectSelection, name='all_step_project_selection'),
    path('sessions/random_ranking_project_selection/<int:session_id>', views_sessions.RandomRankingProjectSelection, name='random_ranking_project_selection'),
    path('sessions/init_order_project_selection/<int:session_id>', views_sessions.InitOrderProjectSelection, name='init_order_project_selection'),

    path('sessions/step_rank_rand_project_selection/<int:session_id>', views_sessions.StepRankRandProjectSelection, name='step_rank_rand_project_selection'),
    path('sessions/all_step_rank_rand_project_selection/<int:session_id>', views_sessions.AllStepRankRandProjectSelection, name='all_step_rank_rand_project_selection'),

    path('sessions/enable_ordering_project_selection/<int:session_id>', views_sessions.EnableOrderingProjectSelection, name='enable_ordering_project_selection'),
    path('sessions/load_ranking_project_selection/<int:session_id>', views_sessions.LoadRankingProjectSelection, name='load_ranking_project_selection'),

    path('sessions/generate_project_project_selection/<int:session_id>', views_sessions.GenerateProjectProjectSelection, name='generate_project_project_selection'),
    path('sessions/delete_project_selection/<int:session_id>/<int:projectsel_id>', views_sessions.DeleteProjectSelection, name='delete_project_selection'),



	path('sessions/new_report/<int:session_id>/<int:project_id>/<int:date_report_id>/', views_sessions.SessionReportNewView, name='session_report_new_view'),
    path('sessions/validate_report_tutor/<int:session_id>/<int:report_id>', views_sessions.ReportValidateTutor, name='report_validate_tutor'),

	path('sessions/new_deposit/<int:session_id>/<int:project_id>/<int:date_deposit_id>/', views_sessions.SessionDepositNewView, name='session_deposit_new_view'),
    path('sessions/validate_deposit_tutor/<int:session_id>/<int:deposit_id>', views_sessions.DepositValidateTutor, name='deposit_validate_tutor'),

	path('sessions/git/<int:session_id>/<int:project_id>/', views_sessions.SessionProjectGitView, name='session_project_git_view'),

    # Sessions Admin Views
    path('sessions/admin/<int:pk>/', login_required(views_sessions_admin.SessionAdminDetailView.as_view()), name='session_admin_view'),
    path('sessions/add_members/<int:session_id>/', views_sessions_admin.SessionAdminAddMembers, name='session_admin_add_members_view'),
    path('sessions/remove_members/<int:session_id>/<int:user_id>', views_sessions_admin.SessionAdminRemoveMembers, name='session_admin_remove_members_view'),
    path('sessions/change_description/<int:session_id>', views_sessions_admin.SessionAdminChangeDescription, name='session_admin_change_description_view'),
    path('sessions/change_phase/<int:session_id>', views_sessions_admin.SessionAdminChangePhase, name='session_admin_change_phase_view'),


    # Project Views
    path('projects/view/<int:pk>/', login_required(views_projects.ProjectViewDetailView.as_view()), name='project_view'),
    path('projects/validate_deposit_tutor/<int:project_id>/<int:deposit_id>', views_projects.DepositValidateTutorProject, name='deposit_validate_project'),
    path('projects/validate_report_tutor/<int:project_id>/<int:report_id>', views_projects.ReportValidateTutorProject, name='report_validate_project'),

    path('projects/testMail/<int:project_id>', views_projects.ReportTestMail, name='report_mail'),

    # Test Views
    path('testOrder/', views_tests.testOrder, name='testOrder')
]

sitePTUT/urls.py
from django.contrib import admin
from django.urls import include, path
from django.views.generic.base import TemplateView
from django.conf import settings
from django.conf.urls.static import static

urlpatterns = [
    path('gestion_projets/', include('gestion_projets.urls')),
    path('admin/', admin.site.urls),
    path('accounts/', include('accounts.urls')),
	path('accounts/', include('django.contrib.auth.urls')),
	path('', TemplateView.as_view(template_name='home.html'), name='home'),
]

urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

gestion_projets/views/views_projects.py
from django.http import HttpResponse, HttpResponseRedirect
from django.shortcuts import get_object_or_404, render, redirect
from django.urls import reverse
from django.views import generic
from django.http import JsonResponse
from django.contrib.auth.decorators import login_required

from django.utils import timezone

from ..models import Subject, Session, Project, DateDeposit, Deposit, DateReport, Report, User, ProjectSelection

from datetime import date

from django.core.mail import send_mail

import json



class ProjectViewDetailView(generic.DetailView):
    model = Project
    template_name = 'projects/project_view.html'

    def get_context_data(self, **kwargs):
        # Call the base implementation first to get a context
        context = super().get_context_data(**kwargs)
        user = self.request.user
        # Add in a QuerySet of all the books
        context['session'] = self.object.session
        return context

@login_required
def DepositValidateTutorProject(request, project_id, deposit_id):
    
    if request.user.groups.filter(name='Tutor').exists(): # Vérifie le type d'utilisateur
        project = get_object_or_404(Project, pk=project_id) # Vérifie que le projet existe
        
        if request.user.groups.filter(name=project.session.group): # Vérifie que l'utilisateur à le droit d'accéder à cette session
            if project.session.phase == 3: # Vérifie la phase de la session : Ajout de sujets
                if request.user == project.subject.user or request.user.groups.filter(name='Admin').exists() :# si tuteur du projet ou Admin

                    _deposit = get_object_or_404(Deposit, pk=deposit_id) # Vérifie que le depot existe
                    
                    # Mise à jour du dépôt
                    data = request.POST.copy()
                    _deposit.note = int(data.get('note'))

                    _deposit.is_valid = True
                    _deposit.save()
 
    return HttpResponseRedirect(reverse('gestion_projets:project_view', args=(project_id,)))

@login_required
def ReportValidateTutorProject(request, project_id, report_id):

    if request.user.groups.filter(name='Tutor').exists(): # Vérifie le type d'utilisateur
        project = get_object_or_404(Project, pk=project_id) # Vérifie que le projet existe
        
        if request.user.groups.filter(name=project.session.group): # Vérifie que l'utilisateur à le droit d'accéder à cette session
            if project.session.phase == 3: # Vérifie la phase de la session : Ajout de sujets
                if request.user == project.subject.user or request.user.groups.filter(name='Admin').exists() :# si tuteur du projet ou Admin
                       
                    _report = get_object_or_404(Report, pk=report_id) # Vérifie que le report existe

                    # Mise à jour du rapport
                    data = request.POST.copy()

                    _report.checkbox_contact = data.get('checkbox_contact')=='on'
                    _report.checkbox_task_previous = data.get('checkbox_task_previous')=='on'
                    _report.checkbox_task_next = data.get('checkbox_task_next')=='on'
                    _report.checkbox_members = data.get('checkbox_members')=='on'
                    _report.checkbox_time = data.get('checkbox_time')=='on'
                    _report.comment = data.get('comment')

                    _report.is_valid = True
                    _report.save()
 
    return HttpResponseRedirect(reverse('gestion_projets:project_view', args=(project_id,)))



@login_required
def ReportTestMail(request, project_id):

    if request.user.groups.filter(name='Tutor').exists(): # Vérifie le type d'utilisateur
        project = get_object_or_404(Project, pk=project_id) # Vérifie que le projet existe
        
        if request.user.groups.filter(name=project.session.group): # Vérifie que l'utilisateur à le droit d'accéder à cette session
            if project.session.phase == 3: # Vérifie la phase de la session : Ajout de sujets
                if request.user == project.subject.user or request.user.groups.filter(name='Admin').exists() :# si tuteur du projet ou Admin
                       
                    send_mail(
                        'Mettre le sujet',
                        'Here is the message.',
                        'adrien.peytavie@univ-lyon1.fr',
                        ['adrien.peytavie@liris.cnrs.fr'],
                        fail_silently=False,
                    )
    return HttpResponseRedirect(reverse('gestion_projets:project_view', args=(project_id,)))

gestion_projets/views/views_sessions_admin.py
from django.http import HttpResponse, HttpResponseRedirect
from django.shortcuts import get_object_or_404, render, redirect
from django.urls import reverse
from django.views import generic
from django.http import JsonResponse
from django.contrib.auth.decorators import login_required

from django.utils import timezone

from ..models import Subject, Session, Project, DateDeposit, Deposit, DateReport, Report, User, ProjectSelection

from datetime import date

from django.core.mail import send_mail

import json


class SessionAdminDetailView(generic.DetailView):
    model = Session
    template_name = 'sessions/session_admin.html'

    def get_context_data(self, **kwargs):
        # Call the base implementation first to get a context
        context = super().get_context_data(**kwargs)
        user = self.request.user
        # Add in a QuerySet of all the books
        context['subject_list'] = Subject.objects.all()
        context['project_user'] = Project.objects.filter(users__id__contains = user.id,session__id__contains = self.object.id)
        context['group_list'] = ProjectSelection.objects.filter(session__id__contains = self.object.id)
        context['projectSelection_user'] = ProjectSelection.objects.filter(users__id__contains = user.id,session__id__contains = self.object.id)
        context['members'] = User.objects.filter(groups__name=self.object.group)
        return context


@login_required
def SessionAdminAddMembers(request, session_id):
    
    if request.user.groups.filter(name='Admin').exists(): # Vérifie le type d'utilisateur
        session = get_object_or_404(Session, pk=session_id) # Vérifie que la session existe
        
        _group = session.group

        if request.method == 'POST': # Vérifie la méthode du formulaire
            list_user_string = request.POST.get('description')

            list_user = list_user_string.splitlines()

            for user in list_user:
                # tester existance avec filter ?
                _user = get_object_or_404(User, username=user) # Récupère l'utilisateur

                _group.user_set.add(_user)

        
    return HttpResponseRedirect(reverse('gestion_projets:session_admin_view', args=(session_id,)))

@login_required
def SessionAdminRemoveMembers(request, session_id, user_id):
    
    if request.user.groups.filter(name='Admin').exists(): # Vérifie le type d'utilisateur
        session = get_object_or_404(Session, pk=session_id) # Vérifie que la session existe
        
        _group = session.group

        _user = get_object_or_404(User, pk=user_id) # Récupère l'utilisateur

        if not (_user.groups.filter(name='Admin').exists()):
            _group.user_set.remove(_user)

    return HttpResponseRedirect(reverse('gestion_projets:session_admin_view', args=(session_id,)))


@login_required
def SessionAdminChangeDescription(request, session_id):
    
    if request.user.groups.filter(name='Admin').exists(): # Vérifie le type d'utilisateur
        session = get_object_or_404(Session, pk=session_id) # Vérifie que la session existe
        
        if request.method == 'POST': # Vérifie la méthode du formulaire
            _description = request.POST.get('description')

            session.description = _description

            session.save()

    return HttpResponseRedirect(reverse('gestion_projets:session_admin_view', args=(session_id,)))


@login_required
def SessionAdminChangePhase(request, session_id):
    
    if request.user.groups.filter(name='Admin').exists(): # Vérifie le type d'utilisateur
        session = get_object_or_404(Session, pk=session_id) # Vérifie que la session existe
        
        if request.method == 'POST': # Vérifie la méthode du formulaire
            _phase = request.POST.get('phase')

            session.phase = _phase

            session.save()

    return HttpResponseRedirect(reverse('gestion_projets:session_admin_view', args=(session_id,)))

gestion_projets/views/views_tests.py
from django.http import HttpResponse, HttpResponseRedirect
from django.shortcuts import get_object_or_404, render, redirect
from django.urls import reverse
from django.views import generic
from django.http import JsonResponse
from django.contrib.auth.decorators import login_required

from django.utils import timezone

from ..models import Subject, Session, Project, DateDeposit, Deposit, DateReport, Report, User, ProjectSelection

from datetime import date

from django.core.mail import send_mail

import json



@login_required
def testOrder(request):# add session id and group
    data = request.POST.copy()
    selection = ProjectSelection.objects.create(order=data.get('order'))
    selection.save()
    # 'text,test'.split(',')

    return HttpResponse(
            json.dumps({"nothing to see": "this isn't happening"}),
            content_type="application/json"
        )
 

gestion_projets/templates/subjects/subject_edit_detail.html
<!-- templates/home.html -->
{% extends 'base.html' %}
{% load gestion_projets_extras %}
{% load static %}

{% block title %}Edition d'un sujet{% endblock %}
{% block titlePage %}Edition d'un sujet{% endblock %}

{% block menu %}
	{% if user.is_authenticated %}
		{% include "includes/menu.html" with active_tab='tab1' %}
	{% endif %}
{% endblock %}

{% block breadcrumbs %}
<li class="page-item"><a href="{% url 'home' %}" class="page-link"><span class="mif-list"></span></a></li>
<li class="page-item"><a href="{% url 'gestion_projets:subject_list' %}" class="page-link">Sujets</a></li>
<li class="page-item"><a href="{% url 'gestion_projets:subject_edit' pk=subject.id %}" class="page-link">Edition</a></li>
{% endblock %}

{% block content %}
<div class="m-3">
    <div class="remark primary">
        <p><b>Explication :</b> Vous pouvez éditer votre sujet autant de fois que vous le voulez.</p>
        <p>Attention de ne pas modifier un sujet déjà utilisé dans une session.</p>
    </div>

    <div class="panel mt-4" >

		{% if error_message %}<p><strong>{{ error_message }}</strong></p>{% endif %}


		
		<form action="{% url 'gestion_projets:subject_Fn' subject.id %}" method="post">
			{% csrf_token %}
			
            <div class="row p-5">
                <div class="cell-2 text-bold">Titre du sujet</div>
                <div class="cell-10">
                    <input type="text" name="title" data-role="input" value="{{ subject.title }}" >
                </div>
            </div>

            <div class="row p-5">
                <div class="cell-2 text-bold">Description</div>
                <div class="cell-10"> 
                    <div style="max-height: 350px !important; overflow-y: auto;">
                        <textarea id="description" name="description">
                            {{ subject.description }}
                        </textarea>
                    </div>
                </div>
            </div>

            <div class="row p-5">
                <div class="cell-2 text-bold">Difficulté du sujet</div>
                <div class="cell-10">
                    <input name="difficulty" data-role="rating" data-values="1, 2, 3, 4, 5" data-star-color="cyan" data-value="{{ subject.difficulty }}"><br>
                </div>
            </div>

            <div class="row p-5">
                <div class="cell-2 text-bold">Tags</div>
                <div class="cell-10">
                    <input type="text" name="tags" data-role="taginput" data-max-tags="5" 
                    value="{% for tag in subject.tags.all %}{{ tag.text }}{% if not forloop.last %}, {% endif %}{% endfor %} " >
                    <p>5 tags maximum, séparer les tags par des virgules</p>
                </div>
            </div>

            <div class="row p-5">
                <div class="cell-2 text-bold">Technologies</div>
                <div class="cell-10">
                    <input type="text" name="technologies" data-role="taginput" data-max-tags="5" 
                        value="{% for tech in subject.technologies.all %}{{ tech.text }}, {% endfor %} ">
                    <p>5 technologies maximum (php, android, c++, ...), séparer les technologies par des virgules</p>
                </div>
            </div>
            
            <div class="row p-5">
                <div class="cell-2"> </div>
                <div class="cell-10">
                    <button id="success" class="image-button success" type="submit" value="SubjectFn">
                        <span class="mif-checkmark icon"></span>
                        <span class="caption">Valider</span>
                    </button>

                    <!--button id="return" class="image-button alert">
                        <span class="mif-cross icon"></span>
                        <span class="caption">Annuler</span>
                    </button-->
                </div>
            </div>

		</form>
	</div>

    <script type="module">
        import { initializeCKEditor } from "{% static "js/ckeditor-init.js" %}";
        initializeCKEditor('#description');
    </script>
{% endblock %}

gestion_projets/templates/subjects/subject_list.html
<!-- templates/home.html -->
{% extends 'base.html' %}
{% load gestion_projets_extras %}

{% block title %}Sujets{% endblock %}
{% block titlePage %}Liste de Sujets{% endblock %}

{% block menu %}
	{% if user.is_authenticated %}
		{% include "includes/menu.html" with active_tab='tab1' %}
	{% endif %}
{% endblock %}

{% block breadcrumbs %}
<li class="page-item"><a href="{% url 'home' %}" class="page-link"><span class="mif-list"></span></a></li>
<li class="page-item"><a href="{% url 'gestion_projets:subject_list' %}" class="page-link">Sujets</a></li>
<li class="page-item"><a href="{% url 'gestion_projets:subject_list' %}" class="page-link">Liste</a></li>
{% endblock %}

{% block content %}
<div class="m-3">

    <div class="remark primary">
        <p><b>Explication :</b> Affichage de l'ensemble des sujets de tous les utilisateurs de tous les temps.</p>
        <p> Vous pouvez modifier uniquement les sujets que vous avez déposés.</p>
        <p> Attention, un sujet doit être affecté a une session pour pouvoir être affecté à un groupe d'étudiant cela signifie aussi que vous pouvez préparer vos brouillons.</p>
    </div>

    <div class="row mt-2">
        <div class="cell-lg-3 cell-sm-6 mt-2">
            <div class="icon-box border bd-cyan">
                <div class="icon bg-cyan fg-white"><span class="mif-cog"></span></div>
                <div class="content p-4">
                    <div class="text-upper">Vos sujets</div>
                    <div class="text-upper text-bold text-lead">{{ user|count_subjects_user }}</div>
                </div>
            </div>
        </div>
        <div class="cell-lg-3 cell-sm-6 mt-2">
            <div class="icon-box border bd-red">
                <div class="icon bg-red fg-white"><span class="mif-cog"></span></div>
                <div class="content p-4">
                    <div class="text-upper">Nombre de sujets</div>
                    <div class="text-upper text-bold text-lead">{{ latest_subject_list.count }}</div>
                </div>
            </div>
        </div>
    </div>

    <div class="panel mt-4" >
        <div class="row p-5">
            <button class="image-button info" onclick="location.href='{% url 'gestion_projets:subject_new' %}'">
                <span class="mif-upload icon"></span>
                <span class="caption">Nouveau sujet</span>
            </button>
        </div>
        <div class="row p-5">

            {% if latest_subject_list %}
                <table class="table striped row-border" data-role="table" data-show-search="true" data-show-rows-steps="false" data-table-search-title="Rechercher : " style="max-width:100%;" data-cell-wrapper="false">
                    <thead>
                        <tr>
                            <th data-size="40%">Titre</th>
                            <th data-size="20%">Tuteur</th>
                            <th data-size="20%">Tags</th>
                        {% if request.user|has_group:"Tutor" or request.user|has_group:"Admin" %}
                            <th data-size="5%">Vues</th>
                        {% endif %}
                            <th data-size="15%">Action</th>
                        </tr>
                    </thead>
                    <tbody>
                    {% for subject in latest_subject_list %}
                        <tr>
                            <td style="max-width:10%;">{{ subject.title }}</td>
                            <td >{{ subject.user.first_name }} {{ subject.user.last_name }}</td>
                            <td >    
                                {% for tags in subject.tags.all %}
                                    {{ tags.text }}     
                                {% endfor %}
                            </td>
                        {% if request.user|has_group:"Tutor" or request.user|has_group:"Admin" %}
                            <td>{{ subject.nb_view }}</td>
                        {% endif %}
                            <td >
                                <button class="image-button success" onclick="location.href='{% url 'gestion_projets:subject_view' subject.id %}'">
                                    <span class="mif-file-text icon"></span>
                                    <span class="caption">Voir</span>
                                </button>
                                {% if user == subject.user %}
                                    <button class="image-button info" onclick="location.href='{% url 'gestion_projets:subject_edit' subject.id %}'">
                                        <span class="mif-wrench icon"></span>
                                        <span class="caption">Editer</span>
                                    </button>
                                    <!--a class="button" href="">Supprimer</a-->
                                {% endif %}
                            </td>
                        </tr>    
                    {% endfor %}
                    </tbody>
                </table>
            {% else %}
                <p>Aucun sujet disponible.</p>
            {% endif %}
            </div>
    </div>
</div>
{% endblock %}

gestion_projets/templates/subjects/subject_new.html
{% extends 'base.html' %}
{% load gestion_projets_extras %}
{% load static %}

{% block title %}Nouveau sujet{% endblock %}
{% block titlePage %}Nouveau sujet{% endblock %}

{% block menu %}
    {% if user.is_authenticated %}
        {% include "includes/menu.html" with active_tab='tab1' %}
    {% endif %}
{% endblock %}

{% block breadcrumbs %}
<li class="page-item"><a href="{% url 'home' %}" class="page-link"><span class="mif-list"></span></a></li>
<li class="page-item"><a href="{% url 'gestion_projets:subject_list' %}" class="page-link">Sujets</a></li>
<li class="page-item"><a href="{% url 'gestion_projets:subject_new' %}" class="page-link">Nouveau</a></li>
{% endblock %}

{% block content %}
<div class="m-3">
    <div class="panel mt-4" >

        {% if error_message %}<p><strong>{{ error_message }}</strong></p>{% endif %}
        
        <form action="{% url 'gestion_projets:subject_FnNew' %}" method="post">
            {% csrf_token %}
            
            <div class="row p-5">
                <div class="cell-2 text-bold">Titre du sujet</div>
                <div class="cell-10">
                    <input type="text" name="title" data-role="input"  >
                </div>
            </div>

            <div class="row p-5">
                <div class="cell-2 text-bold">Description</div>
                <div class="cell-10"> 
                    <div style="max-height: 350px !important; overflow-y: auto;">
                        <textarea id="description" name="description"></textarea>
                    </div>
                </div>
            </div>
            
            <div class="row p-5">
                <div class="cell-2 text-bold">Difficulté du sujet</div>
                <div class="cell-10">
                    <input name="difficulty" data-role="rating" data-values="1, 2, 3, 4, 5" data-star-color="cyan" ><br>
                </div>
            </div>

            <div class="row p-5">
                <div class="cell-2 text-bold">Tags</div>
                <div class="cell-10">
                    <input type="text" name="tags" data-role="taginput" data-max-tags="5"  >
                    <p>5 tags maximum, séparer les tags par des virgules</p>
                </div>
            </div>

            <div class="row p-5">
                <div class="cell-2 text-bold">Technologies</div>
                <div class="cell-10">
                    <input type="text" name="technologies" data-role="taginput" data-max-tags="5"  >
                    <p>5 technologies maximum (php, android, c++, ...), séparer les technologies par des virgules</p>
                </div>
            </div>
            
            <div class="row p-5">
                <div class="cell-2"> </div>
                <div class="cell-10">
                    <button id="success" class="image-button success" type="submit" value="subject_FnNew">
                        <span class="mif-checkmark icon"></span>
                        <span class="caption">Valider</span>
                    </button>
                </div>
            </div>
        </form>
    </div>
</div>

<script type="module">
    import { initializeCKEditor } from "{% static "js/ckeditor-init.js" %}";
    initializeCKEditor('#description');
</script>
{% endblock %}